//+------------------------------------------------------------------+
//|                                         MACD_ColorHist_Alert.mq4 |
//|                                    Copyright  2006, Robert Hill |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, Robert Hill"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  CLR_NONE
#property  indicator_color2  CLR_NONE
#property  indicator_color3  Green
#property  indicator_color4  Red
#property  indicator_color5  Green
#property  indicator_color6  Red

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3


//---- indicator parameters

extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;

extern int OsmaMultiplier=2;
extern string note1= "OSMA Cross Zero - UP/DOWN";
extern bool AlertON=true;

extern string note2= "OSMA going - UP/DOWN";
extern bool Alert2ON=false;

extern bool EmailON=false;
extern bool OsmaZeroLineCrossAlert=true;
extern bool OsmaDirChangeUpDnAlert=true;

extern bool   ShowText         = true;
extern int    TextPositionX    = 640;
extern int    TextPositionY    = 10;
extern int    Fontsize         = 9;
extern color  UpTextcolor      = Blue;
extern color  DnTextcolor      = Red;


//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];


double HistogramBufferUp[];
double HistogramBufferDown[];

double HistogramBufferUp1[];
double HistogramBufferDown1[];

string TextDir = "OSMA Text";


int flagval1 = 0;
int flagval2 = 0;
int flagval11 = 0;
int flagval21 = 0;

//---- variables

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
//   IndicatorBuffers(3);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexDrawBegin(0,SlowEMA);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexDrawBegin(1,SignalSMA);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,HistogramBufferUp);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,HistogramBufferDown);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(4,HistogramBufferUp1);
   SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexBuffer(5,HistogramBufferDown1);



//   SetIndexDrawBegin(2,SlowEMA + SignalSMA);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OSMA("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+


int deinit() 
{ 
   ObjectDelete(TextDir);return(0); 
}


int start()
  {
   int limit;
   double temp,temp1;
   
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;                          //try i+shift just below after close and also TriggerOnClosed below agai
//---- macd counted in the 1-st buffer
  
      for(int i=0; i<limit; i++)
     
      ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd buffer
      for(i=0; i<limit; i++)
       
       
       ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalSMA,0,MODE_SMA,i);
//     ind_buffer2[i] = alpha*ind_buffer1[i] + alpha_1*ind_buffer2[i+1];

   for(i=0; i<limit; i++)
   {
     
      HistogramBufferUp[i]    = 0.0;
      HistogramBufferDown[i]  = 0.0;
      HistogramBufferUp1[i]   = 0.0;
      HistogramBufferDown1[i] = 0.0;
       
       if (OsmaMultiplier<=0)OsmaMultiplier=1;
      
      temp = (ind_buffer1[i] - ind_buffer2[i])*OsmaMultiplier;
      temp1 = (ind_buffer1[i+1] - ind_buffer2[i+1])*OsmaMultiplier;
    
     if (temp >0) 
       {
        if (temp-temp1>0)
          {       
          HistogramBufferUp[i] = temp;
          }
          else
          { 
          HistogramBufferUp1[i] = temp;
          HistogramBufferUp [i] = 0.0;
          }
       }    
      else
       {  
         if (temp-temp1>0)
          {       
        HistogramBufferDown[i] = temp; 
          }  
        else 
           {
        HistogramBufferDown1[i] = temp;   
        HistogramBufferDown[i] = 0.0;
           }
      } 
     
        if (i == 1)
        {

//
//      if (HistogramBufferUp[i] > 0 && HistogramBufferDown1[i + 1] < 0)
        if (HistogramBufferUp[i] >  HistogramBufferUp[i + 1])
         {
// Cross up
        if (flagval1==0)
         {
         flagval1=1;
         flagval2=0;
         
         if ((AlertON)&&(OsmaZeroLineCrossAlert)) Alert("OSMA BUY Signal - ",Symbol()," M",Period());
         if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma Crossed Zero UP", "Osma CrossedZero up, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
         HistogramBufferUp[i]=EMPTY_VALUE;
         }
         }
   
         else if (HistogramBufferUp[i] <  HistogramBufferUp[i + 1] )
         {




// Cross down
         if (flagval2==0)
          {
          flagval2=1;
          flagval1=0;
          if ((AlertON)&&(OsmaZeroLineCrossAlert))Alert("OSMA SELL Signal - ",Symbol()," M",Period());
          if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma Crossed Zero DOWN","Osma CrossedZero Down, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
          HistogramBufferDown[i]=EMPTY_VALUE;
          }
          }
          else if (HistogramBufferUp[i+ 1] >  HistogramBufferUp1[i])
          {


// dn
          if (flagval11==0)
          {
          flagval11=1;
          flagval21=0;
          if ((Alert2ON)&&(OsmaZeroLineCrossAlert)) Alert("OSMA SELL Signal - ",Symbol()," M",Period());
          if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma going Down", "Osma going Down, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
          HistogramBufferDown[i]=EMPTY_VALUE;
           
          }
          }
//

          else if (HistogramBufferDown[i] >  HistogramBufferDown1[i+ 1])
          {
// up
          if (flagval21==0)
          {
          flagval11=0;
          flagval21=1;
          if ((Alert2ON)&&(OsmaZeroLineCrossAlert))Alert("OSMA BUY Signal - ",Symbol()," M",Period());
          if ((EmailON)&&(OsmaZeroLineCrossAlert)) SendMail("Osma going Up", "Osma going Up, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
          HistogramBufferUp[i]=EMPTY_VALUE;
       
  
      
      }
    //     }


    //  }
      
 //  }
      
//---- done
   return(0);
  }
  
  
   }
   }
   for (i=0; i<Bars; i++)
  {
      if (HistogramBufferUp[i]!=EMPTY_VALUE) { Commenter(1); break; }
      if (HistogramBufferDown[i]!=EMPTY_VALUE) { Commenter(-1); break; }
   }      
   return(0);
}
  
 void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
      ObjectSet(TextDir,OBJPROP_XDISTANCE,TextPositionX);
      ObjectSet(TextDir,OBJPROP_YDISTANCE,TextPositionY);
      if (Dir == 1) ObjectSetText(TextDir,"OSMA BUY",Fontsize,"Arial Black", UpTextcolor);
      if (Dir ==-1) ObjectSetText(TextDir,"OSMA SELL",Fontsize,"Arial Black",DnTextcolor);
   }
   
return; 
}
 
  
  
  
  
  